"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.asParallel = void 0;
const fromParallel_1 = require("../../parallel/static/fromParallel");
/**
 * Converts an async iterable to a Parallel Enumerable.
 * @param source AsyncIterable<T> to convert to IParallelEnumerable<T>
 * @returns Parallel Enumerable of source
 */
function asParallel(source) {
    async function generator() {
        const data = [];
        for await (const value of source) {
            data.push(value);
        }
        return data;
    }
    return fromParallel_1.fromParallel(0 /* PromiseToArray */, generator);
}
exports.asParallel = asParallel;
