"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.each = void 0;
const BasicAsyncEnumerable_1 = require("../BasicAsyncEnumerable");
/**
 * Performs a specified action on each element of the Iterable<TSource>
 * @param source The source to iterate
 * @param action The action to take an each element
 * @returns A new IAsyncEnumerable<T> that executes the action lazily as you iterate.
 */
exports.each = (source, action) => {
    async function* iterator() {
        for await (const value of source) {
            action(value);
            yield value;
        }
    }
    return new BasicAsyncEnumerable_1.BasicAsyncEnumerable(iterator);
};
