"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.max = void 0;
const shared_1 = require("../../shared");
function max(source, selector) {
    if (selector) {
        return max2(source, selector);
    }
    else {
        return max1(source);
    }
}
exports.max = max;
const max1 = async (source) => {
    let maxItem = null;
    for await (const item of source) {
        maxItem = Math.max(maxItem || Number.NEGATIVE_INFINITY, item);
    }
    if (maxItem === null) {
        throw new shared_1.InvalidOperationException(shared_1.ErrorString.NoElements);
    }
    else {
        return maxItem;
    }
};
const max2 = async (source, selector) => {
    let maxItem = null;
    for await (const item of source) {
        maxItem = Math.max(maxItem || Number.NEGATIVE_INFINITY, selector(item));
    }
    if (maxItem === null) {
        throw new shared_1.InvalidOperationException(shared_1.ErrorString.NoElements);
    }
    else {
        return maxItem;
    }
};
