"use strict";
// LINQ to TypeScript
// Copyright (c) Alexandre Rogozine
// MIT License
// https://github.com/arogozine/LinqToTypeScript/blob/master/LICENSE
Object.defineProperty(exports, "__esModule", { value: true });
const tslib_1 = require("tslib");
// API design adapted from,
// LINQ: .NET Language-Integrated Query
// API is part of .NET Core foundational libraries (CoreFX)
// MIT License
// https://github.com/dotnet/corefx/blob/master/LICENSE.TXT
// API Documentation adapted from,
// LINQ API Documentation
// Create Commons Attribution 4.0 International
// https://github.com/dotnet/docs/blob/master/LICENSE
// Shared Interfacess
tslib_1.__exportStar(require("./types"), exports);
// Types and Stuff
tslib_1.__exportStar(require("./shared"), exports);
var ArrayEnumerable_1 = require("./sync/ArrayEnumerable");
Object.defineProperty(exports, "ArrayEnumerable", { enumerable: true, get: function () { return ArrayEnumerable_1.ArrayEnumerable; } });
// Main Initializer
tslib_1.__exportStar(require("./initializer/initializer"), exports);
// Static Methods
tslib_1.__exportStar(require("./sync/static"), exports);
tslib_1.__exportStar(require("./async/static"), exports);
tslib_1.__exportStar(require("./parallel/static"), exports);
// Type Check
var isEnumerable_1 = require("./sync/isEnumerable");
Object.defineProperty(exports, "isEnumerable", { enumerable: true, get: function () { return isEnumerable_1.isEnumerable; } });
var isParallelEnumerable_1 = require("./parallel/isParallelEnumerable");
Object.defineProperty(exports, "isParallelEnumerable", { enumerable: true, get: function () { return isParallelEnumerable_1.isParallelEnumerable; } });
var isAsyncEnumerable_1 = require("./async/isAsyncEnumerable");
Object.defineProperty(exports, "isAsyncEnumerable", { enumerable: true, get: function () { return isAsyncEnumerable_1.isAsyncEnumerable; } });
