"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.bindArray = void 0;
const ArrayEnumerable_1 = require("../sync/ArrayEnumerable");
/**
 * Binds LINQ method to a built in array type
 * @param jsArray Built In JS Array Type
 */
exports.bindArray = (jsArray) => {
    const propertyNames = Object.getOwnPropertyNames(ArrayEnumerable_1.ArrayEnumerable.prototype)
        // eslint-disable-next-line @typescript-eslint/array-type
        .filter((v) => v !== "constructor");
    for (const prop of propertyNames) {
        // eslint-disable-next-line @typescript-eslint/no-unsafe-assignment, @typescript-eslint/no-unsafe-member-access
        jsArray.prototype[prop] = jsArray.prototype[prop] || ArrayEnumerable_1.ArrayEnumerable.prototype[prop];
    }
};
