import { IEnumerable } from "../types";
/**
 * Basic Enumerable. Usually returned from the Enumerable class.
 * @private
 */
export declare class BasicEnumerable<TSource> {
    private readonly iterator;
    constructor(iterator: () => IterableIterator<TSource>);
    [Symbol.iterator](): IterableIterator<TSource>;
}
/**
 * Work around for lack of good support for circular module references in JS.
 * private Use @see {IEnumerable} instead
 */
export interface BasicEnumerable<TSource> extends IEnumerable<TSource> {
}
