"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.groupByWithResult = void 0;
const shared_1 = require("../../shared");
const BasicEnumerable_1 = require("../BasicEnumerable");
const groupByShared_1 = require("./groupByShared");
function groupByWithResult(source, keySelector, resultSelector, comparer) {
    if (comparer) {
        return groupBy_2(source, keySelector, resultSelector, comparer);
    }
    else {
        return groupBy_2_Simple(source, keySelector, resultSelector);
    }
}
exports.groupByWithResult = groupByWithResult;
function groupBy_2_Simple(source, keySelector, resultSelector) {
    function* iterator() {
        const groupByResult = groupByShared_1.groupBy_0_Simple(source, keySelector);
        for (const group of groupByResult()) {
            yield resultSelector(group.key, group);
        }
    }
    return new BasicEnumerable_1.BasicEnumerable(iterator);
}
function groupBy_2(source, keySelector, resultSelector, comparer = shared_1.StrictEqualityComparer) {
    function* iterator() {
        const groupByResult = groupByShared_1.groupBy_0(source, keySelector, comparer);
        for (const group of groupByResult()) {
            yield resultSelector(group.key, group);
        }
    }
    return new BasicEnumerable_1.BasicEnumerable(iterator);
}
