"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.reverse = void 0;
const BasicEnumerable_1 = require("../BasicEnumerable");
/**
 * Inverts the order of the elements in a sequence.
 * @param source A sequence of values to reverse.
 * @returns A sequence whose elements correspond to those of the input sequence in reverse order.
 */
exports.reverse = (source) => {
    function* iterator() {
        for (const x of [...source].reverse()) {
            yield x;
        }
    }
    return new BasicEnumerable_1.BasicEnumerable(iterator);
};
