import { ErrorString, InvalidOperationException } from "../../shared";
import { BasicParallelEnumerable } from "../BasicParallelEnumerable";
import { nextIteration } from "./_nextIteration";
export async function max(source, selector) {
    let maxInfo;
    if (selector) {
        const dataFunc = nextIteration(source, selector);
        maxInfo = await new BasicParallelEnumerable(dataFunc).toArray();
    }
    else {
        maxInfo = await source.toArray();
    }
    if (maxInfo.length === 0) {
        throw new InvalidOperationException(ErrorString.NoElements);
    }
    return Math.max.apply(null, maxInfo);
}
