import { BasicEnumerable } from "../BasicEnumerable";
/**
 * Iterates through the object
 * @param source Source Object
 * @returns IEnumerabe<[TKey, TValue]> of Key Value pairs
 */
export const enumerateObject = (source) => {
    function* iterable() {
        // eslint-disable-next-line guard-for-in
        for (const key in source) {
            yield [key, source[key]];
        }
    }
    return new BasicEnumerable(iterable);
};
